"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.initComputedStyleAccumulator = initComputedStyleAccumulator;
function initComputedStyleAccumulator(Stack, build_state) {
    const targets = build_state.expressive_computeTargets = [];
    return Object.assign(Object.create(Stack),
    //add listener to context
    { program: {
            computedStyleMayInclude(element) {
                targets.push(element);
            }
        } });
}

class ExplicitStyle {

    constructor(name, value) {
        this.id = t.identifier(name);
        this.name = name;
        this.static = value;
        switch (typeof value) {
            case "number":
                value = value.toString();
            case "string":
                this.value = t.stringLiteral(value);
                this.inlineType = "style_static";
                break;
            default:
                this.static = false;
                this.inlineType = "style";
                this.value = value.node;
        }
    }

    get asString() {
        const name = this.name.replace(/([A-Z]+)/g, "-$1").toLowerCase();
        let { static: value } = this;

        return `${name}: ${value}; `;
    }

    get asProperty() {
        return t.objectProperty(this.id, this.value);
    }

    asAssignedTo(target) {
        return t.expressionStatement(t.assignmentExpression("=", t.memberExpression(target, this.id), this.value));
    }
}
exports.ExplicitStyle = ExplicitStyle;
//# sourceMappingURL=style.js.map